#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127

int main (int argc, char *argv[])
{
  FILE *afh;
  char buf[MAXBC+1];
  int tot = 0;

  if (argc != 2)
  {
    fprintf (stderr, "errore: inserire il nome del file\n");
    exit (1);
  }

  if ((afh = fopen(argv[1],"r")) == NULL)
  {
    fprintf (stderr, "errore: non riesco ad aprire il file '%s' in lettura\n", argv[1]);
    exit (1);
  }

  while (fgets(buf, MAXBC+1, afh) != NULL)
  {
    int num;
    if (sscanf(buf,"%d",&num) != 1)
    {
      fprintf (stderr, "errore: riga priva di dati\n");
      exit (1);
    }
    tot += num;
  }

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: chiusura del file '%s' non riuscita\n", argv[1]);

  printf ("totale: %d\n", tot);

  return 0;
}
