#include <stdio.h>
#include <stdlib.h>

#define BLANK ' '
#define EOL '\n'

int main ()
{
  int xc;
  enum {Inizio, Centro, Spazio} stato = Inizio;

  while ((xc=getchar()) != EOF)
  {
    switch (stato)
    {
    case Inizio:
      if (xc == EOL)
        putchar (EOL);
      else if (xc != BLANK) {
        putchar (xc);
        stato = Centro;
      }
      break;
    case Centro:
      if (xc == EOL) {
        putchar (EOL);
        stato = Inizio;
      }
      else if (xc == BLANK)
        stato = Spazio;
      else
        putchar (xc);
      break;
    case Spazio:
      if (xc == EOL) {
        putchar (EOL);
        stato = Inizio;
      }
      else if (xc != BLANK) {
        putchar (BLANK);
        putchar (xc);
        stato = Centro;
      }
      break;
    default:
      fprintf (stderr, "bug: caso impossibile nello switch()\n");
      exit (1);
    }
  }

  return 0;
}
