/* soluzione esame 21/2/2011 - SENZA CONTROLLI */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXNOME 20
#define MAXBC 127
#define ARCHIVIO "montagne.txt"

#define BOOLEAN int
#define FALSE 0
#define TRUE (!FALSE)

struct _montagna {
  char nome[MAXNOME+1];
  double latitudine;
  double longitudine;
  long altezza;
}

typedef struct _montagna montagna;
  
double distanza (double x, double y, montagna m)
{
  return sqrt (
    (x - m.latitudine) * (x - m.latitudine)
    +
    (y - m.longitudine) * (y - m.longitudine)
  );
}


int main (int argc, char *argv[])
{
  montagna monte, min_monte;
  double dist, min_dist;
  BOOLEAN primo_monte = TRUE;
  double myLat, myLong;
  FILE *afh;
  char buf[MAXBC+1];

  sscanf (argv[1], "%lf", myLat);
  sscanf (argv[2], "%lf", myLong);

  afh = fopen (ARCHIVIO, "r");

  while (fgets(buf,MAXBC,afh) != NULL)
  {
    sscanf (buf, "%s %lf %lf %ld",
      &monte.nome, &monte.latitudine, &monte.longitudine, &monte.altezza);
    dist = distanza (myLat, myLong, monte);
    if (primo_monte)
    {
      min_dist = dist;
      min_monte = monte;
      primo_monte = FALSE;
    }
    else
    {
      if (dist < min_dist)
      {
        min_dist = dist;
        min_monte = monte;
      }
    }
  }

  fprintf ("Monte piu' vicino: %s (altezza %lf)\n",
    min_monte.nome. min_monte.altezza);

  return 0;
}
