#include <stdio.h>
#include <stdlib.h>

int main()
{
  const char Slash = '/';
  const char EOL = '\n';
  enum {Normale, UnoSlash, Commento} stato;
  int xc;

  stato = Normale;

  while ((xc=getchar()) != EOF)
  {
    switch (stato)
    {
    case Normale:
      if (xc == Slash)
	stato = UnoSlash;
      else
	putchar (xc);
      break;
    case UnoSlash:
      if (xc == Slash)
	stato = Commento;
      else
      {
        stato = Normale;
        putchar (Slash);
	putchar (xc);
      }
      break;
    case Commento:
      if (xc == EOL)
      {
	stato = Normale;
	putchar (EOL);
      }
      break;
    default:
      fprintf (stderr, "\nbug - stato impossibile\n");
      exit (1);
    }
  }

  return 0;
}
