#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define RICAVI "ricavi.txt"
#define RICAVI2 "ricavi2.txt"
#define MAXBC 127
#define NGIORNI 366

struct _datobase
{
   long qty;
   long val;
};

typedef struct _datobase datobase;

int main (int argc,char *argv[])
{
   FILE *afh;
   char buf[MAXBC+1];
   int i;
   datobase contab[NGIORNI];

   afh = fopen (RICAVI,"r");
   for (i=0; i<NGIORNI; i++)
   {
      fgets (buf,MAXBC,afh);
      sscanf (buf, "%ld %ld", &contab[i].qty, &contab[i].val);
   }
   fclose (afh);

   if (argc == 4)
   {
      if (strcmp(argv[1],"stat") == 0)
      {
         int inizio, fine, ng=0;
         long totqty=0, totval=0;
         sscanf (argv[2], "%d", &inizio);
         sscanf (argv[3], "%d", &fine);
         for (i=inizio-1; i<=fine-1; i++)
         {
            if ((contab[i].qty != -1) && (contab[i].val != -1))
            {
               ng++;
               totqty += contab[i].qty;
               totval += contab[i].val;
            }
         }
         printf ("Statistiche per i giorni dal %d al %d:\n", inizio, fine);
         printf ("- giorni lavorativi = %d\n", ng);
         printf ("- quantita' media = %.1lf/giorno\n", totqty/(double)ng);
         printf ("- ricavo medio = %.1lf/giorno\n", totval/(double)ng);
      }
   }
   else if (argc == 5)
   {
      if (strcmp(argv[1],"add") == 0)
      {
         int giorno, g;
         long qty, val;

         sscanf (argv[2], "%d", &giorno);
         sscanf (argv[3], "%ld", &qty);
         sscanf (argv[4], "%ld", &val);
         g = giorno - 1;
         if ((contab[g].qty==-1) && (contab[g].val==-1)) {
            contab[g].qty = qty;
            contab[g].val = val;
         }
         else {
            contab[g].qty += qty;
            contab[g].val += val;
         }

         afh = fopen (RICAVI2,"w");
         for (i=0; i<NGIORNI; i++)
            fprintf (afh, "%ld %ld\n", contab[i].qty, contab[i].val);
         fclose (afh);
      }
   }

   return 0;
}
